import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.imageio.ImageIO;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.Timer;


public class TypeYourHeartOut extends JPanel{


	private static enum Mode{
		title, tutorial_1, tutorial_2, tutorial_3, tutorial_4, tutorial_5, tutorial_6, play, dead, win;
	}
	
	long startTime;
	long totalTime;

	Mode mode = Mode.title; 

	int beatsInARow = 0;
	int missedBeatsInARow = 0;


	HeartbeatPanel heartbeatPanel = new HeartbeatPanel(this);
	WordPanel wordPanel = new WordPanel();

	double heartHealth = 100;
	double wordHealth = 100;

	double heartLoss = .25;
	double wordLoss = .1;

	double heartGain = 10;
	double wordGain = 10;

	JProgressBar heartProgressBar = new JProgressBar(JProgressBar.VERTICAL, 0, 100);
	JProgressBar wordProgressBar = new JProgressBar(JProgressBar.VERTICAL, 0, 100);


	List<String> words = new ArrayList<String>();
	List<BufferedImage> wordImages = new ArrayList<BufferedImage>();
	BufferedImage deathImage;

	String currentWord;
	int currentLetterIndex = 0;

	int currentWordIndex = 0;

	
	public TypeYourHeartOut(){

		words.add("practice");
		words.add("practice more");
		words.add("ready");
		words.add("brushing");
		words.add("bowling");
		words.add("cook");
		words.add("jog");
		words.add("shop");
		words.add("snowball");
		words.add("soccer");
		words.add("television");
		words.add("sleep");
		words.add("dream");
		words.add("win");
		
		try {
			wordImages.add(ImageIO.read(this.getClass().getClassLoader().getResource("images/brushing.jpg")));
			wordImages.add(ImageIO.read(this.getClass().getClassLoader().getResource("images/bowling.jpg")));
			wordImages.add(ImageIO.read(this.getClass().getClassLoader().getResource("images/cook.jpg")));
			wordImages.add(ImageIO.read(this.getClass().getClassLoader().getResource("images/jogging.jpg")));
			wordImages.add(ImageIO.read(this.getClass().getClassLoader().getResource("images/shopping.jpg")));
			wordImages.add(ImageIO.read(this.getClass().getClassLoader().getResource("images/snowball.jpg")));
			wordImages.add(ImageIO.read(this.getClass().getClassLoader().getResource("images/soccer.jpg")));
			wordImages.add(ImageIO.read(this.getClass().getClassLoader().getResource("images/tv.jpg")));
			wordImages.add(ImageIO.read(this.getClass().getClassLoader().getResource("images/sleep.jpg")));
			wordImages.add(ImageIO.read(this.getClass().getClassLoader().getResource("images/baby.jpg")));
			
			deathImage = ImageIO.read(this.getClass().getClassLoader().getResource("images/death.jpg"));
			
		} 
		catch (IOException e) {
			e.printStackTrace();
		}

		currentWord = words.get(0);

		wordPanel.setCurrentWord("");
		wordPanel.setCurrentLetterIndex(0);

		setBackground(Color.BLACK);


		addKeyListener(new KeyListener(){

			@Override
			public void keyTyped(KeyEvent e) {


			}

			@Override
			public void keyPressed(KeyEvent e) {
				
				
				if(Mode.title.equals(mode)){
					startTime = System.currentTimeMillis();
					mode = Mode.tutorial_1;
					return;
				}
				
				char typed = Character.toLowerCase(e.getKeyChar());

				if(Character.isWhitespace(typed) || Character.isLetter(typed)){


					char goal = currentWord.charAt(currentLetterIndex);

					if(typed == goal){
						currentLetterIndex++;
						if(currentLetterIndex >= currentWord.length()){
							
							if(Mode.dead.equals(mode) || Mode.win.equals(mode)){
								mode = Mode.title;
								beatsInARow = 0;
								missedBeatsInARow = 0;
								currentWordIndex = 0;
								currentLetterIndex = 0;
								currentWord = "";
								wordPanel.setCurrentWord("");
								wordPanel.setCurrentLetterIndex(0);
								startTime = System.currentTimeMillis();
								return;
							}
							

							if(Mode.tutorial_4.equals(mode)){
								mode = Mode.tutorial_5;
							}
							else if(Mode.tutorial_5.equals(mode)){
								mode = Mode.tutorial_6;
							}
							else if(Mode.tutorial_6.equals(mode)){
								heartHealth = 100;
								wordHealth = 100;
								beatsInARow = 0;
								missedBeatsInARow = 0;
								mode = Mode.play;
							}


							currentWordIndex++;
							
							if(currentWordIndex >= words.size()){
								mode = Mode.win;
								totalTime = System.currentTimeMillis() - startTime;
								currentWord = "retry";
								wordPanel.setCurrentWord("retry");
								wordPanel.setCurrentLetterIndex(0);
								return;
							}
							
							currentLetterIndex = 0;
							currentWord = words.get(currentWordIndex);
							wordHealth += wordGain;
							capHealth();

							wordProgressBar.setValue((int) wordHealth);
						}

						wordPanel.setCurrentWord(currentWord);
						wordPanel.setCurrentLetterIndex(currentLetterIndex);
						wordPanel.repaint();
					}
					else{
						wordHealth -= wordGain;
						capHealth();

						wordProgressBar.setValue((int) wordHealth);
					}
				}
				else{

					if(Mode.tutorial_1.equals(mode)){
						mode = Mode.tutorial_2;
						heartbeatPanel.setAlive(true);
						return;
					}



					if(heartbeatPanel.beat()){

						beatsInARow++;
						missedBeatsInARow = 0;


						if(beatsInARow >= 3 && Mode.tutorial_2.equals(mode)){
							mode = Mode.tutorial_3;
							beatsInARow = 0;
							return;
						}
						else if(beatsInARow >= 3 && Mode.tutorial_3.equals(mode)){
							mode = Mode.tutorial_4;
							beatsInARow = 0;

							currentWord = words.get(0);
							wordPanel.setCurrentWord(currentWord);

							return;
						}


						heartHealth += heartGain;

					}
					else{

						beatsInARow = 0;

						if(Mode.play.equals(mode)){
							heartHealth -= heartGain;
						}
					}
					capHealth();

					heartProgressBar.setValue((int) heartHealth);
				}

				repaint();

			}

			@Override
			public void keyReleased(KeyEvent e) {
				// TODO Auto-generated method stub

			}

		});



		heartProgressBar.setValue((int) heartHealth);
		wordProgressBar.setValue((int) wordHealth);

		heartProgressBar.setForeground(Color.RED);
		wordProgressBar.setForeground(Color.GREEN);


		Timer timer = new Timer(32, new ActionListener(){

			@Override
			public void actionPerformed(ActionEvent e) {
				step();
			}

		});
		timer.start();
		startTime = System.currentTimeMillis();

		setPreferredSize(new Dimension(500, 300));

	}
	
	public void missedBeat(){
		missedBeatsInARow++;
		if(Mode.play.equals(mode)){
			heartHealth -= heartGain*missedBeatsInARow;
		}
	}


	public void step(){


		if(Mode.tutorial_3.equals(mode) || Mode.tutorial_4.equals(mode) || Mode.tutorial_5.equals(mode) || Mode.tutorial_6.equals(mode) || Mode.play.equals(mode)){
			heartHealth -= heartLoss;
		}

		if(Mode.tutorial_5.equals(mode) || Mode.tutorial_6.equals(mode) || Mode.play.equals(mode)){	
			wordHealth -= wordLoss;
		}

		if(!Mode.play.equals(mode)){
			if(heartHealth <= 0){
				heartHealth = 100;
			}
			if(wordHealth <= 0){
				wordHealth = 100;
			}
		}

		capHealth();

		heartProgressBar.setValue((int) heartHealth);
		wordProgressBar.setValue((int) wordHealth);

		heartbeatPanel.step();

		repaint();
	}


	private void capHealth(){


		if(Mode.play.equals(mode)){
			if(wordHealth <= 0 || heartHealth <= 0){
				heartbeatPanel.setAlive(false);
				mode = Mode.dead;
				beatsInARow = 0;
				missedBeatsInARow = 0;
				currentWord = "retry";
				wordPanel.setCurrentWord(currentWord);
				wordPanel.setCurrentLetterIndex(0);
				currentLetterIndex = 0;
			}
		}


		wordHealth = Math.min(Math.max(0, wordHealth), 100);
		heartHealth = Math.min(Math.max(0, heartHealth), 100);
	}
	public void paintComponent(Graphics g){
		super.paintComponent(g);

		if(Mode.title.equals(mode)){
			g.setFont(new Font(Font.DIALOG, Font.PLAIN, 48));
			g.setColor(Color.RED);
			g.drawString("Type Your \u2764 Out", 50, 50);
			
			g.setFont(new Font(Font.DIALOG, Font.PLAIN, 24));
			g.setColor(Color.LIGHT_GRAY);
			g.drawString("Code: Kevin Workman", 90, 130);
			g.drawString("Art: Terry TW", 105, 160);
			
			g.setFont(new Font(Font.DIALOG, Font.PLAIN, 18));
			g.drawString("Press any key to start!", 105, 225);
		}
		else if(Mode.play.equals(mode)){
			
			
			if(currentWordIndex >= 3 && currentWordIndex <= 12){
				g.drawImage(wordImages.get(currentWordIndex - 3), 25, 0, 400, 300, this);
			}
		}
		if(Mode.tutorial_1.equals(mode)){
			g.setFont(new Font(Font.DIALOG, Font.PLAIN, 18));
			g.setColor(Color.LIGHT_GRAY);
			g.drawString("Put your non-dominant hand on a key", 70, 50);
			g.drawString("   that isn't a letter or whitespace.", 70, 70);
			g.drawString("Ctrl ~ , . / ; ' {} or any number work.", 85, 125);
			g.drawString("   Space and enter don't.", 85, 145);
			g.drawString("Press that key to continue.", 105, 225);
		}
		else if(Mode.tutorial_2.equals(mode)){
			g.setFont(new Font(Font.DIALOG, Font.PLAIN, 18));
			g.setColor(Color.LIGHT_GRAY);
			g.drawString("Watch the heart monitor above.", 70, 50);
			g.drawString("When the heartbeat intersects the green monitor line,", 20, 90);
			g.drawString("   press your key to make your heart beat.", 20, 110);
			g.drawString("Don't beat too early or too late!", 85, 150);
			g.drawString("Get 3 in a row to continue.", 105, 225);
		}
		else if(Mode.tutorial_3.equals(mode)){
			g.setFont(new Font(Font.DIALOG, Font.PLAIN, 18));
			g.setColor(Color.LIGHT_GRAY);
			g.drawString("Keep beating...", 120, 50);
			g.drawString("You do this all the time without thinking!", 40, 90);

			g.drawString("Watch your heart health on the right.", 50, 130);

			g.drawString("Keep beating to keep your health up.", 105, 150);
			g.drawString("Get 3 in a row to continue.", 125, 225);
		}
		else if(Mode.tutorial_4.equals(mode)){
			g.setFont(new Font(Font.DIALOG, Font.PLAIN, 18));
			g.setColor(Color.LIGHT_GRAY);
			g.drawString("Keep beating!", 120, 50);
			g.drawString("With your other hand,", 40, 90);
			g.drawString("type the word at the bottom.", 50, 130);


			g.drawString("Type the word to continue.", 125, 225);
		}
		else if(Mode.tutorial_5.equals(mode)){
			g.setFont(new Font(Font.DIALOG, Font.PLAIN, 18));
			g.setColor(Color.LIGHT_GRAY);
			g.drawString("Spaces count!", 120, 50);
			g.drawString("Watch your word health on the left.", 40, 90);
			g.drawString("Get words correct to keep health up.", 50, 130);


			g.drawString("Type the words to continue.", 125, 225);
		}
		else if(Mode.tutorial_6.equals(mode)){
			g.setFont(new Font(Font.DIALOG, Font.PLAIN, 18));
			g.setColor(Color.LIGHT_GRAY);
			g.drawString("If either health bar runs out,", 30, 50);
			g.drawString("You die!", 150, 90);
			g.drawString("Ready to play?", 100, 130);


			g.drawString("Type the word to continue.", 125, 225);
		}
		else if(Mode.dead.equals(mode)){
			
			g.drawImage(deathImage, 25, 0, 400, 300, this);
			
			g.setFont(new Font(Font.DIALOG, Font.PLAIN, 18));
			g.setColor(Color.RED);
			g.drawString("Type the word to retry.", 125, 250);
		}
		else if(Mode.win.equals(mode)){
			g.setFont(new Font(Font.DIALOG, Font.PLAIN, 18));
			g.setColor(Color.LIGHT_GRAY);
			g.drawString("You won!", 200, 100);
			g.drawString("Time: " + totalTime/1000 + " seconds" , 175, 200);


			g.drawString("Type the word to retry.", 150, 250);
		}



	}




	public static void main(String... args){
		JFrame frame = new JFrame("Type Your Heart Out");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);


		TypeYourHeartOut panel = new TypeYourHeartOut();
		frame.add(panel);

		frame.add(panel.heartbeatPanel, BorderLayout.NORTH);

		frame.add(panel.heartProgressBar, BorderLayout.EAST);
		frame.add(panel.wordProgressBar, BorderLayout.WEST);

		frame.add(panel.wordPanel, BorderLayout.SOUTH);

		frame.setSize(500, 500);
		frame.setVisible(true);
		frame.repaint();
		panel.requestFocusInWindow();
	}
}
