import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.geom.Rectangle2D;

import javax.swing.JPanel;


public class WordPanel extends JPanel{
	
	String currentWord;
	int currentLetterIndex;
	

	public WordPanel(){
		setBackground(Color.BLACK);
		setPreferredSize(new Dimension(500, 100));
	}
	
	public void setCurrentWord(String currentWord){
		this.currentWord = currentWord;
		repaint();
	}
	
	public void setCurrentLetterIndex(int currentLetterIndex){
		this.currentLetterIndex = currentLetterIndex;
		repaint();
	}
	
	public void paintComponent(Graphics g){
		super.paintComponent(g);
		
		
		Font font = new Font(Font.DIALOG, Font.PLAIN, 72);
		FontMetrics fontMetrics = this.getFontMetrics(font);
		Rectangle2D bounds = fontMetrics.getStringBounds(currentWord, g);
		
		int x = (int) (getWidth()/2 - bounds.getWidth()/2);
		
		g.setColor(Color.WHITE);
		g.setFont(font);
		g.drawString(currentWord, x, 75);
		
		g.setColor(Color.GREEN);
		g.drawString(currentWord.substring(0, currentLetterIndex), x, 75);
	}

}
